#include <math.h>
#include <stdio.h>



int main(void)
{
  
  double fext = 10000000.00000;
  double fcpu = 11059200.0;//14318181.818181818181818;
  
  fcpu*=1.000000;

  double pi=3.14159265;

  double dp=fext/fcpu;
  double pe=0;
  double pef,pei;
  double r=1;
  int i,k,ix,iy,six,siy,ssx,ssy; 

  int bin[4];
  
  bin[0]=0; bin[1]=0; bin[2]=0; bin[3]=0;


  // quadrature bin sampler. we have 4 bins, and an input pulse moving across the 4 bins.
  // testing and adding can be done by SBIC + INC, 2 clocks. So we advance phase 2 clocks
  // per iteration by default.
  //
  // 14.31818 is 63/44*10MHz = 
  //
  //
  //


  six=0;
  siy=0;
  ssx=0; ssy=0;
  
  pe=0.125*0.00000001;
  for (i=0; i<432; ++i) {
    pef=modf(pe,&pei);
    k=pef*4;
    r=1+(i/20000.0);
    printf("%2i %.3lf %.3lf   %.4lf %4lf %i\n",i,pef,pef*4.0,r*cos(2.0*pi*pef),r*sin(2.0*pi*pef),k);


    //printf("  SBIC TESTPORT,TESTPIN\n  INC  r%i\n",k+16);
    
    ix=127.0*cos(2*pi*pef);
    iy=127.0*sin(2*pi*pef);
/*    
    printf("  lds r0,X+\n");
    printf("  and r0,r24\n");
    printf("  breq sklab%i\n",i);
    printf("  subi r18,lo8(%i)\n",-ix);
    printf("  sbci r19,hi8(%i)\n",-ix);
    printf("  subi r20,lo8(%i)\n",-iy);
    printf("  sbci r21,hi8(%i)\n",-iy);
    printf("sklab%i:\n",i);
*/        
//    printf("  %i,%i,\n",(ix+127),(iy+127));
    six+=ix;
    siy+=iy;
    if (ix>0) ssx+=ix;
    if (iy>0) ssy+=iy;
    
    
    

    bin[k]=bin[k]+1;
  
    
/*    if (i>50)
      if (bin[0]==bin[1])
        if (bin[2]==bin[3])
          if (bin[0]==bin[2]) return 1;

*/






//    if ((i%2)==0) pe+=dp; //insert nop



    pe+=dp;
    pe+=dp;
    pe+=dp;
    pe+=dp;
    pe+=dp;
    pe+=dp;
    pe+=dp;
    pe+=dp;
  }



//  printf("%i %i %i %i\n",bin[0],bin[1],bin[2],bin[3]);
//  printf("sum %i %i  %i %i\n",six,siy,ssx,ssy);


  return 0;
}